(* fresh : (('a * int)list * int) -> 'a -> (int * (('a * int)list * int)) *)
let fresh x (xs,i) = match Lst.lookup x xs with
  | Some y -> (y,(xs,i))
  | None   -> (i,((x,i)::xs,i+1))
(* type term *)
type term = Var of int
          | App of (term * term)
          | Lam of (int * term)
(* t1 : term *)
let t1 = Lam(0,Lam(1,App(Var 0,(App(Var 2,Var 3)))))
(* freshify : int -> term -> term *)
let rec freshify state = function
  | Var x    ->
     let (y,state') = fresh x state in
     (Var y,state')
  | App(s,t) -> 
    let (s',state') = freshify state s in
    let (t',state'') = freshify state' t in
    (App(s',t'),state'')
  | Lam(x,t) ->
    let (y,state')  = fresh x state in
    let (t',state'') = freshify state' t in
    (Lam(y,t'),state'')
(* *)
open StateMonad
(* fresh' *)
let fresh' x =
  get >>= fun(xs,i) -> match Lst.lookup x xs with
  | Some y -> return y
  | None   -> set((x,i)::xs,i+1) >>= fun _ ->
              return i
(* freshify' *)
let rec freshify = function
  | Var x    ->
    fresh' x >>= fun y ->
    return(Var y)
  | App(s,t) ->
    freshify s >>= fun s' ->
    freshify t >>= fun t' ->
    return(App(s',t'))
  | Lam(x,t)  ->
    fresh' x    >>= fun y ->
    freshify t >>= fun t' ->
    return(Lam(y,t'))
(* *)
