open Fresh
open StateMonad

let fresh x = perform
  (xs,i) <-- get;
  match Lst.lookup x xs with
    | Some y -> return y
    | None   -> perform
      set((x,i)::xs,i+1);
      return i

let rec freshify = function
  | Var x    -> perform
    y <-- fresh x;
    return(Var y)
  | App(s,t) -> perform
    s' <-- freshify s;
    t' <-- freshify t;
    return(App(s',t'))
  | Lam(x,t)  -> perform
    y  <-- fresh' x;
    t' <-- freshify t;
    return(Lam(y,t'))
